LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity part1 is
	port
	(
		   KEY : in STD_LOGIC_VECTOR(0 downto 0);	
			SW  : in STD_LOGIC_VECTOR(1 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0)
	);
end;


architecture withFF of part1 is
   signal yn, y : std_logic_vector(8 downto 0);
   signal z : std_logic;
	signal clock, resetn, w : std_logic;
begin

  clock <= KEY(0);
  resetn <= SW(0);
  w <= SW(1);
  LEDR(8 downto 0) <= y;
  LEDR(9) <= z;
  
  yn(0) <= '1';
  
FF0: entity work.D_flipflop(behav)
	port map(yn(0), clock, resetn, '1', y(0));

   yn(1) <= (not y(0) or y(5) or y(6) or y(7) or y(8)) and not w;
   	
FF1: entity work.D_flipflop(behav)
	port map(yn(1), clock, resetn, '1', y(1));
	
	yn(2) <= y(1) and not w;

FF2: entity work.D_flipflop(behav)
	port map(yn(2), clock, resetn, '1', y(2));
	
	yn(3) <= y(2) and not w;

FF3: entity work.D_flipflop(behav)
	port map(yn(3), clock, resetn, '1', y(3));
	
	yn(4) <= (y(3) or y(4)) and not w;

FF4: entity work.D_flipflop(behav)
	port map(yn(4), clock, resetn, '1', y(4));	
	
   yn(5) <= (not y(0) or y(1) or y(2) or y(3) or y(4)) and w;
   	
FF5: entity work.D_flipflop(behav)
	port map(yn(5), clock, resetn, '1', y(5));
	
	yn(6) <= y(5) and  w;

FF6: entity work.D_flipflop(behav)
	port map(yn(6), clock, resetn, '1', y(6));
	
	yn(7) <= y(6) and  w;

FF7: entity work.D_flipflop(behav)
	port map(yn(7), clock, resetn, '1', y(7));
	
	yn(8) <= (y(7) or y(8)) and  w;

FF8: entity work.D_flipflop(behav)
	port map(yn(8), clock, resetn, '1', y(8));	
	
   z<= y(8) or y(4);
	

end architecture;
	
	
	
