LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity part2 is
	port
	(
		   KEY : in STD_LOGIC_VECTOR(0 downto 0);	
			SW  : in STD_LOGIC_VECTOR(1 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0)
	);
end;


architecture withFF of part2 is
	signal clock, resetn, w, z : std_logic;
   TYPE state_type IS (A, B, C, D, E, F, G, H, I);
	attribute syn_encoding : string;
   attribute syn_encoding of State_type : type is "0000 0001 0010 0011 0100 0101 0110 0111 1000";
	
	signal current_state, next_state : state_type;
begin

  clock <= KEY(0);
  resetn <= SW(0);
  w <= SW(1);
  LEDR(9) <= z;
  LEDR(8 downto 4) <= (others=>'0');
  
  
  -- compute next state
  process(current_state, w, resetn) is
  begin
	 z <='0'; 
	 
	 case current_state is
		when A =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= B;
			else 
				next_state <= F;
			end if;
			LEDR(3 downto 0)<="0000";
		when B =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= C;
			else 
				next_state <= F;
			end if;
			LEDR(3 downto 0)<="0001";
		when C =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= D;
			else 
				next_state <= F;
			end if;
			LEDR(3 downto 0)<="0010";
		when D =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= E;
			else 
				next_state <= F;
			end if;
			LEDR(3 downto 0)<="0011";
		when E =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= E;
			else 
				next_state <= F;
			end if;
			LEDR(3 downto 0)<="0100";
			z<='1';
		when F =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= B;
			else 
				next_state <= G;
			end if;
			LEDR(3 downto 0)<="0101";
		when G =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= B;
			else 
				next_state <= H;
			end if;
			LEDR(3 downto 0)<="0110";
		when H =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= B;
			else 
				next_state <= I;
			end if;
			LEDR(3 downto 0)<="0111";
		when I =>
			if resetn='0' then
				next_state <= A;
			elsif w='0' then
				next_state <= B;
			else 
				next_state <= I;
			end if;
			LEDR(3 downto 0)<="1000";
			z<='1';
		end case;
	end process;
	
	process (clock) is
	begin
		if rising_edge(clock) then
			current_state <= next_state;
		end if;
	end process;
 
	

end architecture;
	
	
	
