LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity part3 is
	port
	(
		   KEY : in STD_LOGIC_VECTOR(0 downto 0);	
			SW  : in STD_LOGIC_VECTOR(1 downto 0);	
			LEDR: out STD_LOGIC_VECTOR(9 downto 0)
	);
end;


architecture withFF of part3 is
	signal clock, resetn, w, z : std_logic;
	signal shift_0, shift_1: std_logic_vector(3 downto 0);
	signal shift_0n, shift_1n: std_logic_vector(3 downto 0);

begin

  clock <= KEY(0);
  resetn <= SW(0);
  w <= SW(1);
  LEDR(9) <= z;
  LEDR(3 downto 0) <= shift_0;
  LEDR(7 downto 4) <= shift_1;
  LEDR(8) <= '0';  
  
  process(resetn, w, shift_0, shift_1)
  begin
     if (resetn='0') then
	     shift_0n<="0000";
		  shift_1n<="1111";
	  else
	     shift_0n(2 downto 0)<= shift_0(3 downto 1);
		  shift_0n(3) <= w;
		  shift_1n(2 downto 0)<= shift_1(3 downto 1);
		  shift_1n(3) <= w;
	  end if;
  end process;
  
  process
  begin
     wait until rising_edge(clock);
	  shift_0 <= shift_0n;
	  shift_1 <= shift_1n;
  end process;
  
  z <= '1' when (shift_0="1111" OR shift_1="0000") else '0';
  

end architecture;
	
	
	
