LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY counter IS
	GENERIC ( n : NATURAL := 4; k : NATURAL := 16 );
	PORT ( clock : IN STD_LOGIC;
		reset_n : IN STD_LOGIC;
		enable : IN STD_LOGIC;
		Q : OUT STD_LOGIC_VECTOR(n-1 DOWNTO 0);
		rollover : OUT STD_LOGIC
		);
END ENTITY;

ARCHITECTURE behav OF counter IS
	SIGNAL value : STD_LOGIC_VECTOR(n-1 DOWNTO 0);
BEGIN
	PROCESS (clock, reset_n)
	BEGIN
		IF (reset_n = '0') THEN
			value <= (OTHERS => '0');
		ELSIF (rising_edge(clock)) THEN
		   if (enable='1') THEN
				if value = k-1 then
					rollover <= '1';
					value <= (OTHERS => '0');
				else
					rollover <= '0';
					value <= value + 1;
				end if ;
			end if;
		END IF;
	END PROCESS;
	Q <= value;
END ARCHITECTURE;